<?php
/**
 * Multi Blogger functions and definitions.
 *
 * @link https://developer.wordpress.org/themes/basics/theme-functions/
 *
 * @package multi_blogger
 */

$multi_blogger_theme_data = wp_get_theme();
if( ! defined( 'MULTI_BLOGGER_THEME_VERSION' ) ) define ( 'MULTI_BLOGGER_THEME_VERSION', $multi_blogger_theme_data->get( 'Version' ) );
if( ! defined( 'MULTI_BLOGGER_THEME_NAME' ) ) define( 'MULTI_BLOGGER_THEME_NAME', $multi_blogger_theme_data->get( 'Name' ) );

if ( ! function_exists( 'multi_blogger_setup' ) ) :
/**
 * Sets up theme defaults and registers support for various WordPress features.
 *
 * Note that this function is hooked into the after_setup_theme hook, which
 * runs before the init hook. The init hook is too late for some features, such
 * as indicating support for post thumbnails.
 */
function multi_blogger_setup() {

	// Add default posts and comments RSS feed links to head.
	add_theme_support( 'automatic-feed-links' );

	/*
	 * Let WordPress manage the document title.
	 * By adding theme support, we declare that this theme does not use a
	 * hard-coded <title> tag in the document head, and expect WordPress to
	 * provide it for us.
	 */
	add_theme_support( 'title-tag' );

	/*
	 * Enable support for Post Thumbnails on posts and pages.
	 *
	 * @link https://developer.wordpress.org/themes/functionality/featured-images-post-thumbnails/
	 */
	add_theme_support( 'post-thumbnails' );

	// This theme uses wp_nav_menu() in one location.
	register_nav_menus( array(
		'primary' => esc_html__( 'Primary', 'multi-blogger' ),
	) );

	/*
	 * Switch default core markup for search form, comment form, and comments
	 * to output valid HTML5.
	 */
	add_theme_support( 'html5', array(
		'search-form',
		'comment-list',
		'gallery',
		'caption',
	) );

	/*
	 * Enable support for Post Formats.
	 * See https://developer.wordpress.org/themes/functionality/post-formats/
	 */
	add_theme_support( 'post-formats', array(
		'aside',
		'image',
		'video',
		'quote',
		'link',
		'gallery',
        'status',
        'audio', 
        'chat'
	) );

	// Set up the WordPress core custom background feature.
	add_theme_support( 'custom-background', apply_filters( 'multi_blogger_custom_background_args', array(
		'default-color' => 'ffffff',
		'default-image' => '',
	) ) );

	/* Custom Logo */
    add_theme_support( 'custom-logo', array(
    	'header-text' => array( 'site-title', 'site-description' ),
    ) );

    load_theme_textdomain( 'multi-blogger', get_template_directory() . '/languages' );

	add_theme_support( 'woocommerce' );

    /**
	 * Custom template tags for this theme.
	 */
	require get_template_directory() . '/inc/template-tags.php';

	/**
	 * Custom functions that act independently of the theme templates.
	 */
	require get_template_directory() . '/inc/extra.php';

	/**
	 * Customizer additions.
	 */
	require get_template_directory() . '/inc/customizer.php';

	/**
	 * Social Links Widget
	 */
	require get_template_directory() . '/inc/widget-social-links.php';

	/**
	 * Info Theme
	 */
	require get_template_directory() . '/inc/info.php';

	/**
	 * Info Theme
	 */
	require get_template_directory() . '/inc/sanitization.php';

	/**
	 * Getting Started
	*/
	require get_template_directory() . '/inc/getting-started/getting-started.php';

	/**
	 * setup wizard
	 */
	require get_parent_theme_file_path( '/theme-wizard/config.php' );

	if ( ! defined( 'MULTI_BLOGGER_URL' ) ) {
		define( 'MULTI_BLOGGER_URL', esc_url( 'https://www.themeignite.com/products/multi-blog-wordpress-theme', 'multi-blogger') );
	}
	if ( ! defined( 'MULTI_BLOGGER_FREE_DOC_URL' ) ) {
		define( 'MULTI_BLOGGER_FREE_DOC_URL', esc_url( 'https://demo.themeignite.com/documentation/multi-blogger-free/', 'multi-blogger') );
	}
	if ( ! defined( 'MULTI_BLOGGER_PRO_DOC_URL' ) ) {
		define( 'MULTI_BLOGGER_PRO_DOC_URL', esc_url( 'https://demo.themeignite.com/documentation/multi-blogger-pro/', 'multi-blogger') );
	}
	if ( ! defined( 'MULTI_BLOGGER_DEMO_URL' ) ) {
		define( 'MULTI_BLOGGER_DEMO_URL', esc_url( 'https://demo.themeignite.com/multi-blogger/', 'multi-blogger') );
	}
	if ( ! defined( 'MULTI_BLOGGER_REVIEW_URL' ) ) {
		define( 'MULTI_BLOGGER_REVIEW_URL', esc_url( 'https://wordpress.org/support/theme/multi-blogger/reviews/#new-post', 'multi-blogger') );
	}
	if ( ! defined( 'MULTI_BLOGGER_SUPPORT_URL' ) ) {
		define( 'MULTI_BLOGGER_SUPPORT_URL', esc_url( 'https://wordpress.org/support/theme/multi-blogger/', 'multi-blogger') );
	}
	if ( ! defined( 'MULTI_BLOGGER_BUNDLE_URL' ) ) {
		define( 'MULTI_BLOGGER_BUNDLE_URL', esc_url( 'https://www.themeignite.com/products/wp-theme-bundle', 'multi-blogger') );
	}

}
endif;
add_action( 'after_setup_theme', 'multi_blogger_setup' );

	/**
	 * Implement the Custom Header feature.
	 */
	require get_template_directory() . '/inc/custom-header.php';

/**
 * Set the content width in pixels, based on the theme's design and stylesheet.
 *
 * Priority 0 to make it available to lower priority callbacks.
 *
 * @global int $multi_blogger_content_width
 */
function multi_blogger_content_width() {
	$GLOBALS['content_width'] = apply_filters( 'multi_blogger_content_width', 780 );
}
add_action( 'after_setup_theme', 'multi_blogger_content_width', 0 );


/**
 * Register widget area.
 *
 * @link https://developer.wordpress.org/themes/functionality/sidebars/#registering-a-sidebar
 */
function multi_blogger_widgets_init() {
	register_sidebar( array(
		'name'          => esc_html__( 'Sidebar Option', 'multi-blogger' ),
		'id'            => 'right-sidebar',
		'description'   => '',
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h2 class="widget-title">',
		'after_title'   => '</h2>',
	) );
	register_sidebar( array(
		'name'          => esc_html__( 'Sidebar Two', 'multi-blogger' ),
		'id'            => 'sidebar-2',
		'description'   => '',
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h2 class="widget-title">',
		'after_title'   => '</h2>',
	) );
	register_sidebar( array(
		'name'          => esc_html__( 'Sidebar Three', 'multi-blogger' ),
		'id'            => 'sidebar-3',
		'description'   => '',
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h2 class="widget-title">',
		'after_title'   => '</h2>',
	) );
	register_sidebar( array(
		'name'          => esc_html__( 'Footer One', 'multi-blogger' ),
		'id'            => 'footer-one',
		'description'   => '',
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h2 class="widget-title">',
		'after_title'   => '</h2>',
	) );
    
    register_sidebar( array(
		'name'          => esc_html__( 'Footer Two', 'multi-blogger' ),
		'id'            => 'footer-two',
		'description'   => '',
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h2 class="widget-title">',
		'after_title'   => '</h2>',
	) );
    
    register_sidebar( array(
		'name'          => esc_html__( 'Footer Three', 'multi-blogger' ),
		'id'            => 'footer-three',
		'description'   => '',
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h2 class="widget-title">',
		'after_title'   => '</h2>',
	) );

	register_sidebar( array(
		'name'          => esc_html__( 'Footer Four', 'multi-blogger' ),
		'id'            => 'footer-four',
		'description'   => '',
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h2 class="widget-title">',
		'after_title'   => '</h2>',
	) );

}
add_action( 'widgets_init', 'multi_blogger_widgets_init' );

if( ! function_exists( 'multi_blogger_scripts' ) ) :

/**
 * Enqueue scripts and styles.
 */
function multi_blogger_scripts() {

	// Use minified libraries if SCRIPT_DEBUG is false
    $multi_blogger_build  = ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ) ? '/build' : '';
    $multi_blogger_suffix = ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ) ? '' : '.min';

    wp_enqueue_style( 'bootstrap-style', get_template_directory_uri().'/css/build/bootstrap.css' );

    wp_enqueue_style( 'owl.carousel', get_template_directory_uri() . '/css/build/owl.carousel.css' );

    wp_enqueue_style( 'fontawesome-all', esc_url(get_template_directory_uri()).'/css/all.min.css');

	wp_enqueue_style( 'fontawesome-all', esc_url(get_template_directory_uri()).'/css/all.css');

	wp_enqueue_style( 'multi-blogger-style', get_stylesheet_uri(), array(), MULTI_BLOGGER_THEME_VERSION );

	require get_parent_theme_file_path( '/inc/css_custom.php' );
	wp_add_inline_style( 'multi-blogger-style',$multi_blogger_custom_css );
	
  	wp_enqueue_script( 'multi-blogger-all', get_template_directory_uri() . '/js' . $multi_blogger_build . '/all' . $multi_blogger_suffix . '.js', array( 'jquery' ), '6.1.1', true );
  	wp_enqueue_script( 'multi-blogger-v4-shims', get_template_directory_uri() . '/js' . $multi_blogger_build . '/v4-shims' . $multi_blogger_suffix . '.js', array( 'jquery' ), '6.1.1', true );
  	wp_enqueue_script( 'multi-blogger-modal-accessibility', get_template_directory_uri() . '/js' . $multi_blogger_build . '/modal-accessibility' . $multi_blogger_suffix . '.js', array( 'jquery' ), MULTI_BLOGGER_THEME_VERSION, true );
	wp_enqueue_script( 'owl.carousel', get_template_directory_uri() . '/js/build/owl.carousel.js', array('jquery'), '2.6.0', true );
	wp_enqueue_script( 'multi-blogger-multi-blogger-js', get_template_directory_uri() . '/js/build/custom.js', array('jquery'), MULTI_BLOGGER_THEME_VERSION, true );

	// Wow script.
	wp_enqueue_script( 'wow-jquery', get_template_directory_uri() . '/js/build/wow.js', array('jquery'),'' ,true );
	// Animate CSS
	wp_enqueue_style( 'animate-style', get_template_directory_uri() . '/css/build/animate.css' );

	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}
}
endif;
add_action( 'wp_enqueue_scripts', 'multi_blogger_scripts' );

if( ! function_exists( 'multi_blogger_admin_scripts' ) ) :
/**
 * Addmin scripts
*/
function multi_blogger_admin_scripts() {
	wp_enqueue_style( 'multi-blogger-admin-style',get_template_directory_uri().'/inc/css/admin.css', MULTI_BLOGGER_THEME_VERSION, 'screen' );
}
endif;
add_action( 'admin_enqueue_scripts', 'multi_blogger_admin_scripts' );

function multi_blogger_customize_enque_js(){
	wp_enqueue_script( 'customizer', get_template_directory_uri() . '/inc/js/customizer.js', array('jquery'), '2.6.0', true );
}
add_action( 'customize_controls_enqueue_scripts', 'multi_blogger_customize_enque_js', 0 );


if( ! function_exists( 'multi_blogger_block_editor_styles' ) ) :
/**
 * Enqueue editor styles for Gutenberg
 */
function multi_blogger_block_editor_styles() {
	// Use minified libraries if SCRIPT_DEBUG is false
	$multi_blogger_build  = ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ) ? '/build' : '';
	$multi_blogger_suffix = ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ) ? '' : '.min';
	
	// Block styles.
	wp_enqueue_style( 'multi-blogger-block-editor-style', get_template_directory_uri() . '/css' . $multi_blogger_build . '/editor-block' . $multi_blogger_suffix . '.css' );
}
endif;
add_action( 'enqueue_block_editor_assets', 'multi_blogger_block_editor_styles' );

/**
 * Remove header text setting and control from the Customizer.
 */
function multi_blogger_remove_customizer_setting($wp_customize) {
    // Replace 'your_setting_id' with the actual ID or name of the setting you want to remove
    $wp_customize->remove_control('display_header_text');
    $wp_customize->remove_setting('display_header_text');
}
add_action('customize_register', 'multi_blogger_remove_customizer_setting');

function multi_blogger_custom_blog_banner_title() {
    if (is_404()) {
        echo '<h1 class="entry-title">'. esc_html__( 'Oops! That page can’t be found.', 'multi-blogger' ).'</h1>';
    } elseif (is_search()) {
        echo '<h1 class="entry-title">'. esc_html__( 'Search Result For.', 'multi-blogger' ).' ' . get_search_query() . '</h1>';
    } elseif (is_home() && !is_front_page()) {
        echo '<h1 class="entry-title">'. esc_html__( 'Blogs', 'multi-blogger' ).'</h1>';
    } elseif (function_exists('is_shop') && is_shop()) {
        echo '<h1 class="entry-title">'. esc_html__( 'Shop', 'multi-blogger' ).'</h1>';
    } elseif (is_page()) {
        the_title('<h1 class="entry-title">', '</h1>');
    } elseif (is_single()) {
        the_title('<h1 class="entry-title">', '</h1>');
    } elseif (is_archive()) {
        the_archive_title('<h1 class="entry-title">', '</h1>');
    } else {
        the_archive_title('<h1 class="entry-title">', '</h1>');
    }
	multi_blogger_the_breadcrumb();
}

function multi_blogger_the_breadcrumb() {
    echo '<div class="breadcrumb justify-content-center align-items-center mt-5">';

    if (!is_home()) {
        echo '<a class="home-main align-self-center" href="' . esc_url(home_url()) . '">';
        bloginfo('name');
        echo "</a> >> ";

        if (is_category() || is_single()) {
            the_category(' >> ');
            if (is_single()) {
                echo ' >> <span class="current-breadcrumb">' . esc_html(get_the_title()) . '</span>';
            }
        } elseif (is_page()) {
            echo '<span class="current-breadcrumb">' . esc_html(get_the_title()) . '</span>';
        }
    }

    echo '</div>';
}

function multi_blogger_enqueue_google_fontss() {
    $multi_blogger_heading_font_family = get_theme_mod('multi_blogger_heading_font_family', '');
    $multi_blogger_body_font_family = get_theme_mod('multi_blogger_body_font_family', '');

    // Google Fonts URL builder
    $google_fonts = array(
        'Arial'          => '',
        'Verdana'        => '',
        'Helvetica'      => '',
        'Times New Roman'=> '',
        'Georgia'        => '',
        'Courier New'    => '',
        'Trebuchet MS'   => '',
        'Tahoma'         => '',
        'Palatino'       => '',
        'Garamond'       => '',
        'Impact'         => '',
        'Comic Sans MS'  => '',
        'Lucida Sans'    => '',
        'Arial Black'    => '',
        'Gill Sans'      => '',
        'Segoe UI'       => '',
        'Open Sans'      => 'Open+Sans:wght@400;700',
        'Unbounded'         => 'Unbounded:wght@400;700',
        'Lato'           => 'Lato:wght@400;700',
        'Montserrat'     => 'Montserrat:wght@400;700',
        'Libre Baskerville' => 'Libre+Baskerville:wght@400;700'
    );

    $multi_blogger_google_fonts_url = '';

    if (!empty($google_fonts[$multi_blogger_heading_font_family]) || !empty($google_fonts[$multi_blogger_body_font_family])) {
        $fonts = array();

        if (!empty($google_fonts[$multi_blogger_heading_font_family])) {
            $fonts[] = $google_fonts[$multi_blogger_heading_font_family];
        }

        if (!empty($google_fonts[$multi_blogger_body_font_family])) {
            $fonts[] = $google_fonts[$multi_blogger_body_font_family];
        }

        // Build Google Fonts URL
        $multi_blogger_google_fonts_url = add_query_arg(
            'family',
            implode('|', $fonts),
            'https://fonts.googleapis.com/css2'
        );
    }

    if ($multi_blogger_google_fonts_url) {
        wp_enqueue_style('multi-blogger-google-fonts', $multi_blogger_google_fonts_url, false);
    }
}
add_action('wp_enqueue_scripts', 'multi_blogger_enqueue_google_fontss');


/*-----------------------Typography Function---------------------------------------*/

function multi_blogger_apply_typography() {
    $multi_blogger_heading_font_family = get_theme_mod('multi_blogger_heading_font_family');
    $multi_blogger_body_font_family = get_theme_mod('multi_blogger_body_font_family');

    $multi_blogger_custom_css = '';

    if ($multi_blogger_body_font_family) {
        $multi_blogger_custom_css .= "body, a, a:active, a:hover { font-family: " . esc_html($multi_blogger_body_font_family) . " !important; }";
    }

    if ($multi_blogger_heading_font_family) {
        $multi_blogger_custom_css .= "h1, h2, h3, h4, h5, h6 { font-family: " . esc_html($multi_blogger_heading_font_family) . " !important; }";
    }

    if (!empty($multi_blogger_custom_css)) {
        wp_add_inline_style('multi-blogger-style', $multi_blogger_custom_css);
    }
}
add_action('wp_enqueue_scripts', 'multi_blogger_apply_typography');


/*-----------------------Menu Typography Start---------------------------------------*/

function multi_blogger_menu_customizer_css() {
    $multi_blogger_menu_font_weight = get_theme_mod('multi_blogger_menu_font_weight', '500');
    $multi_blogger_menu_text_transform = get_theme_mod('multi_blogger_menu_text_transform', 'capiltalize');

    $multi_blogger_custom_css = "
        .main-navigation ul li a {
            font-weight: " . esc_html($multi_blogger_menu_font_weight) . ";
            text-transform: " . esc_html($multi_blogger_menu_text_transform) . ";
        }
    ";

    wp_add_inline_style('multi-blogger-style', $multi_blogger_custom_css);
}
add_action('wp_enqueue_scripts', 'multi_blogger_menu_customizer_css');

/*-----------------------Menu Typography End---------------------------------------*/

//
function multi_blogger_custom_manage_css() {
    $multi_blogger_custom_css = '';

    // Slider section disabled
    if ( ! get_theme_mod('multi_blogger_slider_setting', false) ) {
        $multi_blogger_custom_css .= '.our-classes { margin-top: 0px; }';
    }

    // Service section disabled
    if ( ! get_theme_mod('multi_blogger_classes_setting', false) ) {
        $multi_blogger_custom_css .= '.banner-main .banner_inner_box_img img { height: 330px; }';
		$multi_blogger_custom_css .= '.banner_inner_box_img .box-content a { top: 70% }';
    }

    if ( $multi_blogger_custom_css ) {
        echo '<style>' . $multi_blogger_custom_css . '</style>';
    }
}
add_action('wp_head', 'multi_blogger_custom_manage_css');

// Change excerpt length
function multiblogger_custom_excerpt_length( $multi_blogger_length ) {
    return 20; // change to desired number of words
}
add_filter( 'excerpt_length', 'multiblogger_custom_excerpt_length', 999 );

/*-----------------------Menu Typography End---------------------------------------*/

/**
 * AJAX handler to dismiss Whizzie notice
 */
if ( ! function_exists( 'multi_blogger_dismiss_whizzie_notice' ) ) {
    function multi_blogger_dismiss_whizzie_notice() {

        update_user_meta(
            get_current_user_id(),
            'multi_blogger_whizzie_dismissed',
            true
        );

        wp_die();
    }
}
add_action(
    'wp_ajax_multi_blogger_dismiss_whizzie_notice',
    'multi_blogger_dismiss_whizzie_notice'
);

/**
 * Check if Whizzie notice is dismissed
 */
if ( ! function_exists( 'multi_blogger_is_whizzie_dismissed' ) ) {
    function multi_blogger_is_whizzie_dismissed() {

        return (bool) get_user_meta(
            get_current_user_id(),
            'multi_blogger_whizzie_dismissed',
            true
        );

    }
}

/**
 * Reset Whizzie notice when theme is activated
 */
add_action( 'after_switch_theme', function () {

    $users = get_users( array(
        'fields' => 'ID',
    ) );

    foreach ( $users as $user_id ) {
        delete_user_meta( $user_id, 'multi_blogger_whizzie_dismissed' );
    }

});

/**
 * Display the admin notice unless dismissed.
 */
function multi_blogger_dashboard_notice() {
    // Check if the notice is dismissed
    $dismissed = get_user_meta(get_current_user_id(), 'multi_blogger_dismissable_notice', true);

    // Display the notice only if not dismissed
    if (!$dismissed) {
        ?>
        <div class="updated notice notice-success is-dismissible notice-get-started-class" data-notice="get-start">
            <div class="notice-details">
                <div class="notice-content">
                    <h2><?php /* translators: %s: Theme name */
					printf( esc_html__( 'Thanks you for installing %s.', 'multi-blogger' ), '<strong>Multi Blogger</strong>' );?></h2>
                    <p><?php echo esc_html('Your journey to a powerful and stylish website begins here. Let’s get everything set up in just a few clicks!', 'multi-blogger'); ?></p>
                    <div class="notice-btns">
                        <a class="button button-primary getstart"
                           href="<?php echo esc_url(admin_url('themes.php?page=multi-blogger')); ?>"><?php esc_html_e('Getting Started', 'multi-blogger') ?></a>
                       	<a class="button button-primary premium" target="_blank" href="<?php echo esc_url(MULTI_BLOGGER_URL); ?>"><?php esc_html_e('Go To Premium', 'multi-blogger') ?></a>
						<a class="button button-primary demo" target="_blank" href="<?php echo esc_url(MULTI_BLOGGER_DEMO_URL); ?>"><?php esc_html_e('View Demo', 'multi-blogger') ?></a>
                    </div>
                </div>
                <div class="notice-img">
                    <a href="<?php echo esc_url( MULTI_BLOGGER_BUNDLE_URL ); ?>" target="_blank"><img src="<?php echo esc_url( get_template_directory_uri() . '/images/notice.png' ); ?>"></a>
                </div>
            </div>
        </div>
        <?php
    }
}

// Hook to display the notice
add_action('admin_notices', 'multi_blogger_dashboard_notice');

/**
 * AJAX handler to dismiss the notice.
 */
function multi_blogger_dismissable_notice() {
    // Set user meta to indicate the notice is dismissed
    update_user_meta(get_current_user_id(), 'multi_blogger_dismissable_notice', true);
    die();
}

// Hook for the AJAX action
add_action('wp_ajax_multi_blogger_dismissable_notice', 'multi_blogger_dismissable_notice');

/**
 * Clear dismissed notice state when switching themes.
 */
function multi_blogger_switch_theme() {
    // Clear the dismissed notice state when switching themes
    delete_user_meta(get_current_user_id(), 'multi_blogger_dismissable_notice');
}

// Hook for switching themes
add_action('after_switch_theme', 'multi_blogger_switch_theme');
